; Shifter - serial input module for BLINKENmini, LittleLights and BlinkenLeds
; store byte to receive buffer (LittleLights and BlinkenLeds)
; version 0.2.1 date 2006-06-17
; Copyright (C) 2005-2006 Stefan Schuermans <1stein@schuermans.info>
; Copyleft: GNU public license - http://www.gnu.org/copyleft/gpl.html
; a BlinkenArea project - http://www.blinkenarea.org/



; store a data byte into receive buffer
; input: RECV_STEP, RECV_X, RECV_Y, data byte in REG0
; uses: Z, CNT, TMP, REG0, REG1, REG2
;  - used stack depth (without call to this function): 0
RECV_STORE:
        sbrs    RECV_X,4                        ; skip if received byte is at x coordinate 16..17
        rjmp    RECV_STORE_0_15                 ; received byte is at x coordinate 0..15
        mov     REG1,RECV_X                     ; byte_3 (REG1) := x
        mov     REG2,RECV_Y                     ; bit := y
        rjmp    RECV_STORE_COMMON
RECV_STORE_0_15:
        mov     REG1,RECV_Y                     ; byte_3 (REG1) := y + (x % 2) * 8
        ldi     TMP,8
        sbrc    RECV_X,0
        add     REG1,TMP
        mov     REG2,RECV_X                     ; bit (REG2) := x / 2
        lsr     REG2
        rjmp    RECV_STORE_COMMON
